- Main Page
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Friends

# FbxClassId Class Reference

This reference page is linked to from the following overview topics: List of Python Fbx classes.

Search for all occurrences

## Detailed Description

Internal class used to differentiate objects during run-time.

Essentially, each class has an unique ClassId, that the system can request in order to test if the class match the description. This class implement the necessary tools to be able to perform hierarchic class testing. This means that a class B that inherits from the class A will answer yes to a "Is A" query of type A or B, but will answer no to a class C that can still inherit from A. All class must inherit from FbxPlug before they can have their own ClassId. Generally, classes inherit from FbxObject rather than FbxPlug, since it offer much more functionality and support throughout the FBX SDK API. When using the standard macros to create new types of objects in the FBX SDK, a static ClassId will automatically be generated for that new class.

When objects are exported to an FBX file, their class type is maintained using 3 sort of strings. They are the Object Type string, the Object Sub Type string and the Object Type Prefix. There is no good or bad way to choose the value of these identifiers, but it is preferable to use meaningful values to keep the ASCII version of FBX readable and easy to understand.

See also:
  FbxPlug, FbxObject

Definition at line 46 of file fbxplug.h.

`#include <fbxplug.h>`

List of all members.

## Public Member Functions
| FbxClassId ()
| Constructor.
| FbxClassId (const char *pClassName, const FbxClassId &pParentClassId, FbxPlugCreateProc pConstructor=0, const char *pFBXType=NULL, const char *pFBXSubType=NULL)
| Advanced constructor were we can specify the general parameters for this ClassId.
void | Destroy ()
| Destructor.
const char * | GetName () const
| Retrieve the class name.
FbxClassId | GetParent () const
| Retrieve the parent ClassId.
FbxPlug * | Create (FbxManager &pManager, const char *pName, const FbxPlug *pFrom)
| Create an instance of this class.
bool | Override (FbxPlugCreateProc pConstructor)
| Override the function pointer method to construct this object.
bool | Is (FbxClassId const pId) const
| Test if this class is a hierarchical children of the specified class type.
bool | operator== (const FbxClassId &pClassId) const
| Equivalence operator.
bool | operator!= (const FbxClassId &pClassId) const
| Inequivalence operator.
FbxClassIdInfo * | GetClassIdInfo ()
| Retrieve the information associated to this ClassId.
const FbxClassIdInfo * | GetClassIdInfo () const
| Retrieve the information associated to this ClassId.
const char * | GetFbxFileTypeName (bool pAskParent=false) const
| Retrieve the FBX file Object Type string associated to this class.
const char * | GetFbxFileSubTypeName () const
| Retrieve the FBX file Object Sub Type string associated to this class.
bool | IsValid () const
| Find out if self ClassId is valid or not.
void | SetObjectTypePrefix (const char *pObjectTypePrefix)
| Set the Object Type Prefix string associated to this class.
const char * | GetObjectTypePrefix ()
| Retrieve the Object Type Prefix string associated to this class.
FbxPropertyHandle * | GetRootClassDefaultPropertyHandle ()
| Retrieve the root property handle of this class.
int | ClassInstanceIncRef ()
| Increase the instance reference count for this class type.
int | ClassInstanceDecRef ()
| Decrease the instance reference count for this class type.
int | GetInstanceRef ()
| Retrieve the instance reference count for this class type.
## Friends
class | FbxManager

## Constructor & Destructor Documentation

FbxClassId | ( |  | ) |

Constructor.

FbxClassId | ( | const char * | pClassName,
|  | const FbxClassId & | pParentClassId,
|  | FbxPlugCreateProc | pConstructor = `0`,
|  | const char * | pFBXType = `NULL`,
|  | const char * | pFBXSubType = `NULL`
| ) |  |

Advanced constructor were we can specify the general parameters for this ClassId.

Parameters:

  pClassName | The name of the class represented.
  pParentClassId | The parent ClassId of this class.
  pConstructor | A function pointer to a construction method for this ClassId.
  pFBXType | The FBX file Object Type string associated to this class.
  pFBXSubType | The FBX file Object Sub Type string associated to this class.

## Member Function Documentation

void Destroy | ( |  | ) |

Search for all occurrences

Destructor.

const char* GetName | ( |  | ) | const

Search for all occurrences

Retrieve the class name.

Returns:
  The class identification string name.

FbxClassId GetParent | ( |  | ) | const

Search for all occurrences

Retrieve the parent ClassId.

Returns:
  The parent ClassId.

FbxPlug* Create | ( | FbxManager & | pManager,
|  | const char * | pName,
|  | const FbxPlug * | pFrom
| ) |  |

Search for all occurrences

Create an instance of this class.

Parameters:

  pManager | The FBX SDK Manager to be used to instantiate this object. This allow the object to use the same memory manager as the provided manager.
  pName | The name to assign to this new object instance.
  pFrom | An object to clone if it matches the same ClassId. This is an optional parameter.

Returns:
  The newly created instance of this class.

bool Override | ( | FbxPlugCreateProc | pConstructor | ) |

Search for all occurrences

Override the function pointer method to construct this object.

Parameters:

  pConstructor | A newly defined function pointer to a construction method to replace the existing one.

Returns:
  True if the operation was successful.

bool Is | ( | FbxClassId const | pId | ) | const

Search for all occurrences

Test if this class is a hierarchical children of the specified class type.

This is the standard method to differentiate object classes.

Parameters:

  pId | The class type to test against self.

Returns:
  True if the object is a hierarchical children of the type specified.

Remarks:
  This function will perform a complete search until it reaches the top level class, but it will stop as soon as one ClassId matches the test.

bool operator== | ( | const FbxClassId & | pClassId | ) | const

Equivalence operator.

Parameters:

  pClassId | The class type to test against self.

Returns:
  True if the ClassId is exactly the same.

Remarks:
  This function only perform direct equality test, and doesn't test hierarchic children.

bool operator!= | ( | const FbxClassId & | pClassId | ) | const

Inequivalence operator.

Parameters:

  pClassId | The class type to test against self.

Returns:
  True if the ClassId is not the same.

Remarks:
  This function only perform direct inequality test, and doesn't test hierarchic children.

FbxClassIdInfo* GetClassIdInfo | ( |  | ) | `[inline]`

Search for all occurrences

Retrieve the information associated to this ClassId.

Returns:
  Various class information such as the constructor function pointer or the parent ClassId.

Definition at line 113 of file fbxplug.h.

    { return mClassInfo; }

const FbxClassIdInfo* GetClassIdInfo | ( |  | ) | const `[inline]`

Search for all occurrences

Retrieve the information associated to this ClassId.

Returns:
  Various class information such as the constructor function pointer or the parent ClassId.

Definition at line 118 of file fbxplug.h.

    { return mClassInfo; }

const char* GetFbxFileTypeName | ( | bool | pAskParent = `false` | ) | const

Search for all occurrences

Retrieve the FBX file Object Type string associated to this class.

Parameters:

  pAskParent | If True, retrieve the parent ClassId, but only if self ClassId is not valid.

Returns:
  The FBX file Object Type string associated to this class.

const char* GetFbxFileSubTypeName | ( |  | ) | const

Search for all occurrences

Retrieve the FBX file Object Sub Type string associated to this class.

Parameters:

  pAskParent | If True, retrieve the parent ClassId, but only if self ClassId is not valid.

Returns:
  The FBX file Object Sub Type string associated to this class.

bool IsValid | ( |  | ) | const `[inline]`

Search for all occurrences

Find out if self ClassId is valid or not.

Returns:
  True if self ClassId is valid.

Definition at line 136 of file fbxplug.h.

    { return mClassInfo ? true : false; }

void SetObjectTypePrefix | ( | const char * | pObjectTypePrefix | ) |

Search for all occurrences

Set the Object Type Prefix string associated to this class.

This will change the "ObjectTypePrefix::" found in front of object name in the FBX file. This is useful to differentiate objects by their name without using the Object Type or Sub Type strings in the file.

Parameters:

  pObjectTypePrefix | The Object Type Prefix string.

const char* GetObjectTypePrefix | ( |  | ) |

Search for all occurrences

Retrieve the Object Type Prefix string associated to this class.

Returns:
  The Object Type Prefix string.

FbxPropertyHandle* GetRootClassDefaultPropertyHandle | ( |  | ) |

Search for all occurrences

Retrieve the root property handle of this class.

This is useful to access the default property hierarchy for this class. This allow users to retrieve information such as the default value for all properties of this class.

Returns:
  The root property handle for this class.

int ClassInstanceIncRef | ( |  | ) |

Search for all occurrences

Increase the instance reference count for this class type.

Returns:
  The new count of reference to this class after increment.

int ClassInstanceDecRef | ( |  | ) |

Search for all occurrences

Decrease the instance reference count for this class type.

Returns:
  The new count of reference to this class after decrement.

int GetInstanceRef | ( |  | ) |

Search for all occurrences

Retrieve the instance reference count for this class type.

Returns:
  The reference count of this class type.

## Friends And Related Function Documentation

friend class FbxManager `[friend]`

Search for all occurrences

Definition at line 188 of file fbxplug.h.

The documentation for this class was generated from the following file:

- fbxsdk/core/fbxplug.h

FbxClassId FbxClassId FbxClassId FbxClassId FbxClassId FbxClassId FbxClassId FbxClassId FbxClassId FbxClassId
FbxClassId FbxClassId FbxClassId FbxClassId FbxClassId FbxClassId FbxClassId FbxClassId FbxClassId FbxClassId